<?xml version='1.0' encoding='UTF-8' ?>
<!--
  Nick's web site: Final XHTML output stage

  Copyright © 2018 Nick Bowler

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <https://www.gnu.org/licenses/>
-->
<xsl:stylesheet version='1.0'
  xmlns='http://www.w3.org/1999/xhtml'
  xmlns:xhtml='http://www.w3.org/1999/xhtml'
  xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
  exclude-result-prefixes='xhtml'>

<xsl:output method='xml' encoding='UTF-8' indent='yes'
  doctype-public='-//W3C//DTD XHTML 1.1//EN'
  doctype-system='http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd' />
<xsl:strip-space elements='*' />

<xsl:param name='source-uri'
  select='"//git.draconx.ca/gitweb/homepage.git/blob/"' />
<xsl:param name='site-title' select='"The Citrine Citadel"' />

<xsl:template match='node()|@*'>
  <xsl:copy><xsl:apply-templates select='node()|@*' /></xsl:copy>
</xsl:template>

<xsl:template match='source'>
  <p>
    <xsl:text>This document was compiled from </xsl:text>
    <a href='{concat($source-uri, revision, ":", file)}'>
      <xsl:value-of select='file' />
    </a>
    <xsl:text> on </xsl:text>
    <xsl:value-of select='compiletime' />
    <xsl:text>.</xsl:text>
  </p>
</xsl:template>

<xsl:template match='/'>
  <html>
    <head>
      <meta name='viewport' content='width=device-width, initial-scale=1' />
      <link rel='stylesheet' type='text/css' href='/style.css' />
      <title>
        <xsl:variable name='page-title' select='string(/document/title)' />
        <xsl:if test='$page-title and $site-title != $page-title'>
          <xsl:value-of select='concat($page-title, " – ")' />
        </xsl:if>
        <xsl:value-of select='$site-title' />
      </title>
    </head>
    <body>
      <xsl:apply-templates select='/document/xhtml:html/@*' />
      <xsl:apply-templates select='/document/xhtml:html/node()' />

      <div id='footer'>
        <xsl:apply-templates select='/document/source' />
      </div>
    </body>
  </html>
</xsl:template>

</xsl:stylesheet>
